<template>
  <div class="page-wrapper" :class="themeClasses" v-if="restaurant && account">
    <restaurant-header
      :groupId="groupId"
      :loading="loading"
      :restaurant="restaurant"
    />

    <div class="container">
      <div class="row justify-content-end">
        <div class="col-12 col-md-9">
          <form class="waiting-form" :class="themeClasses">
            <template v-if="!finished">
              <div class="account-info-container" v-if="isLogin">
                <hello-member />
              </div>

              <div class="form-field">
                <div class="form-content">
                  <span class="form-field-label">{{
                    $t("waitingForm.waitingGroupSize")
                  }}</span>

                  <div>
                    <div class="picker-control-wrapper selector">
                      <select
                        :disabled="disabled"
                        v-model="adultGroupSize"
                        class="picker-control"
                      >
                        <option :value="0">{{
                          $t("waitingForm.nAdult", { n: 0 })
                        }}</option>
                        <option
                          v-for="n in availableAdultGroupSize"
                          :key="n"
                          :value="n"
                          >{{ $t("waitingForm.nAdult", { n }) }}</option
                        >
                      </select>
                    </div>

                    <div class="picker-control-wrapper selector">
                      <select
                        :disabled="disabled"
                        v-model="childGroupSize"
                        class="picker-control"
                      >
                        <option :value="0">{{
                          $t("waitingForm.nKid", { n: 0 })
                        }}</option>
                        <option
                          v-for="n in availableChildGroupSize"
                          :key="n"
                          :value="n"
                          >{{ $t("waitingForm.nKid", { n }) }}</option
                        >
                      </select>
                    </div>
                  </div>

                  <span class="description">{{
                    $t("waitingForm.maxGroupSize", { n: maxWaitingGroupSize })
                  }}</span>
                </div>
              </div>

              <!--
              <div class="form-field" v-if="!editContact">
                <span class="form-field-label form-content">{{ $t('waitingForm.contactInfo') }} <span class="description">{{ $t('waitingForm.contactInfoDesc') }}</span></span>

                <div class="field-display">
                  <span class="field-display-label">{{ $t('waitingForm.contactName') }}</span>
                  <span class="field-display-value">{{ contactName }}</span>
                  <span class="field-display-label">{{ $t('waitingForm.contactPhone') }}</span>
                  <span class="field-display-value">{{ contactPhone }}</span>
                </div>

                <button class="edit-button" @click.prevent.stop="edit()">{{ $t('waitingForm.editContactInfo') }}</button>
              </div>
              -->

              <template v-if="editContact">
                <div class="form-field">
                  <div class="form-content">
                    <span class="form-field-label"
                      >{{ $t("waitingForm.contactName") }}*</span
                    >
                    <div class="name-input-wrapper">
                      <input
                        :disabled="disabled"
                        v-model="contactName"
                        type="text"
                        name="name"
                        class="form-control"
                      />
                      <div class="picker-control-wrapper gender-selector">
                        <select
                          :disabled="disabled"
                          v-model="genderType"
                          class="picker-control"
                        >
                          <option value="male">{{
                            $t("account.gender.male")
                          }}</option>
                          <option value="female">{{
                            $t("account.gender.female")
                          }}</option>
                        </select>
                      </div>
                    </div>
                  </div>
                </div>

                <div class="form-field">
                  <div class="form-content">
                    <span class="form-field-label"
                      >{{ $t("waitingForm.contactPhone") }}*
                      <span class="description">{{
                        $t("waitingForm.contactInfoDesc")
                      }}</span></span
                    >
                    <input
                      :disabled="disabled"
                      v-model="contactPhone"
                      type="tel"
                      name="phone"
                      class="form-control"
                    />
                  </div>
                </div>
              </template>

              <div class="form-field">
                <div class="form-content">
                  <span class="form-field-label">{{
                    $t("waitingForm.note")
                  }}</span>
                  <textarea
                    :disabled="disabled"
                    class="form-control note-editor"
                    v-model="note"
                    row="5"
                    :placeholder="$t('waitingForm.notePlaceholder')"
                  ></textarea>
                </div>
              </div>

              <div class="form-field" v-if="childGroupSize > 0">
                <div class="form-content">
                  <span class="form-field-label">{{
                    $t("waitingForm.additionalRequirement")
                  }}</span>
                  <div class="requirement-list">
                    <div
                      class="requirement-item"
                      v-if="!restaurant.webKidChairsSelectorHidden"
                    >
                      <input
                        id="ar-kidSet"
                        :disabled="disabled"
                        v-model="kidSet"
                        name="ar"
                        class="form-checkbox"
                        type="checkbox"
                      />
                      <label for="ar-kidSet" class="form-checkbox-label">{{
                        $t(`waitingForm.additionalRequirements.kidSet`)
                      }}</label>

                      <select
                        :disabled="disabled || !kidSet"
                        v-model="kidSetNum"
                        class="picker-control"
                      >
                        <option :value="0">0</option>
                        <option
                          v-for="n in childGroupSize"
                          :value="n"
                          :key="n"
                          >{{ n }}</option
                        >
                      </select>
                      <span>{{
                        $t(`waitingForm.additionalRequirements.kidSetUnit`)
                      }}</span>
                    </div>

                    <div class="requirement-item">
                      <input
                        id="ar-pram"
                        :disabled="disabled"
                        v-model="pram"
                        name="ar"
                        class="form-checkbox"
                        type="checkbox"
                      />
                      <label for="ar-pram" class="form-checkbox-label">{{
                        $t(`waitingForm.additionalRequirements.pram`)
                      }}</label>

                      <select
                        :disabled="disabled || !pram"
                        v-model="pramNum"
                        class="picker-control"
                      >
                        <option :value="0">0</option>
                        <option
                          v-for="n in childGroupSize"
                          :value="n"
                          :key="n"
                          >{{ n }}</option
                        >
                      </select>
                      <span>{{
                        $t(`waitingForm.additionalRequirements.pramUnit`)
                      }}</span>
                    </div>

                    <span class="c-secondary-black requirement-item-desc">{{
                      $t("waitingForm.additionalRequirements.hint")
                    }}</span>
                  </div>
                </div>
              </div>

              <div class="form-content" v-if="reservation.error">
                <div class="error-message">
                  {{ $t(`errorCodes.${reservation.error.code}`) }}
                </div>
              </div>

              <div class="buttons">
                <button
                  :disabled="disabled || invalid"
                  class="button"
                  @click.prevent.stop="submit()"
                >
                  {{ $t("waitingForm.submit") }}
                </button>
                <button
                  :disabled="disabled || invalid"
                  class="button disabled"
                  @click.prevent.stop="back()"
                >
                  {{ $t("waitingForm.back") }}
                </button>
              </div>
            </template>

            <template v-if="finished">
              <div class="account-info-container succeeded">
                <hello-member />
              </div>

              <div class="success-message">
                <span
                  class="message-1"
                  v-html="
                    $t('waitingForm.succeeded.message1', {
                      level: account.levelTitle
                    })
                  "
                ></span>
                <span class="message-2">{{
                  $t("waitingForm.smsSent", { phone: contactPhone })
                }}</span>
              </div>

              <div class="buttons">
                <button
                  :disabled="disabled"
                  class="button"
                  @click.prevent.stop="viewReservation()"
                >
                  {{ $t("waitingForm.viewReservation") }}
                </button>
                <button
                  :disabled="disabled"
                  class="button disabled"
                  @click.prevent.stop="backToHome()"
                >
                  {{ $t("waitingForm.backToHome") }}
                </button>
              </div>
            </template>
          </form>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapActions, mapState, mapGetters, mapMutations } from "vuex";
import HelloMember from "@/components/HelloMember";
import RestaurantHeader from "@/components/Restaurant/Header";
import eventBus from "@/event-bus";
import { RESERVATION_CREATED } from "@/store/restaurant";

export default {
  components: {
    RestaurantHeader,
    HelloMember
  },

  data() {
    return {
      finished: false,
      editContact: false,
      newContactName: null,
      newContactPhone: null,
      newGenderType: null,
      adultGroupSize: 2,
      childGroupSize: 0,
      note: null,
      kidSet: false,
      kidSetNum: 0,
      pram: false,
      pramNum: 0
    };
  },

  props: {
    id: {
      required: true
    },
    groupId: {
      required: true
    },
    companyId: {
      required: true
    }
  },

  computed: {
    ...mapState(["locale"]),
    ...mapState("restaurant", ["restaurant", "loading", "reservation"]),
    ...mapState("account", ["account"]),
    ...mapGetters("account", ["isLogin", "isVipMember"]),
    ...mapGetters("theme", ["themeClasses"]),

    accountLoading() {
      return this.$store.state.account.loading;
    },

    disabled() {
      return this.reservation.creating;
    },

    invalid() {
      return !(this.contactName && this.contactPhone && this.genderType);
    },

    maxWaitingGroupSize() {
      return this.restaurant.maxWaitingGroupSize || 12;
    },

    availableAdultGroupSize() {
      return this.maxWaitingGroupSize - this.childGroupSize;
    },

    availableChildGroupSize() {
      var size = this.maxWaitingGroupSize - this.adultGroupSize;
      size = size < 0 ? 0 : size;
      return size;
    },

    contactName: {
      get() {
        var name = this.account.name;
        if (this.isVipMember) {
          name = name[0];
        }
        return this.editContact ? this.newContactName : name;
      },
      set(val) {
        this.newContactName = val;
      }
    },

    contactPhone: {
      get() {
        return this.editContact
          ? this.newContactPhone
          : this.account.phoneNumber;
      },
      set(val) {
        this.newContactPhone = val;
      }
    },

    genderType: {
      get() {
        return this.editContact ? this.newGenderType : this.account.genderType;
      },
      set(val) {
        this.newGenderType = val;
      }
    }
  },

  watch: {
    accountLoading(val) {
      if (!val && !this.account) {
        this.$router.push({ name: "Restaurant" });
      }
    },

    pram(val) {
      if (!val) {
        this.pramNum = 0;
      }
    },

    kidSet(val) {
      if (!val) {
        this.kidSetNum = 0;
      }
    },

    account() {
      this.editContact = false;
      this.edit();
    }
  },

  methods: {
    ...mapActions("restaurant", [
      "fetchRestaurant",
      "createWaiting",
      "clearReservation"
    ]),
    ...mapMutations("restaurant", ["setRestaurant"]),

    submit() {
      this.createWaiting({
        CompanyId: this.restaurant.company.id,
        BranchId: this.restaurant.id,
        ContactName: this.contactName,
        contactPhone: this.contactPhone,
        genderType: this.genderType,
        adultGroupSize: this.adultGroupSize,
        childGroupSize: this.childGroupSize,
        note: this.note || "",
        kidSet: this.kidSet,
        kidSetNum: this.kidSetNum,
        pram: this.pram,
        pramNum: this.pramNum,
        language: this.locale,
        MemberID: this.account.data.memberId,
        MemberLevel: this.account.data.level,
        MemberEmail: "",
        MemberAddress: "",
        MemberBirthday: ""

        // MemberPhone: this.account.data.phoneNumber,
        // MemberLevel: this.account.data.level,
        // MemberName: this.account.data.name,
        // MemberCard: this.account.data.cardNumb,
      });
    },

    edit() {
      this.newContactName = this.contactName;
      this.newContactPhone = this.contactPhone;
      this.newGenderType = this.genderType || "male";
      this.editContact = true;
    },

    back() {
      this.$router.push({ name: "Restaurant" });
    },

    reservationCreated() {
      if (!this.reservation.error) {
        this.finished = true;
      }
    },

    viewReservation() {
      location.href = this.reservation.link;
    },

    backToHome() {
      this.$router.push({ name: "Group" });
    }
  },

  mounted() {
    const { groupId, companyId, id } = this;
    this.clearReservation();
    this.fetchRestaurant({
      groupId,
      companyId,
      id,
      params: { language: this.locale }
    });
    eventBus.$on(RESERVATION_CREATED, this.reservationCreated);
    if (this.account) {
      this.edit();
    }
  },

  destroyed() {
    eventBus.$off(RESERVATION_CREATED, this.reservationCreated);
    this.clearReservation();
    this.setRestaurant(undefined);
  }
};
</script>

<style lang="scss" scoped>
.page-wrapper.theme-vip-member {
  background: $color-gold-100;
}

.waiting-form {
  padding: 30px 20px;
  color: $color-secondary-black;

  @include media-breakpoint-up(md) {
    background-color: $color-white;
    margin: 40px 0 0;
    padding: 40px 65px;

    &.theme-vip-member {
      margin-bottom: 40px;
    }
  }
}

.card-level {
  color: $color-skm-red;

  &.theme-vip-member {
    color: $color-skm-gold;
  }
}

.account-name {
  font-weight: bold;
}

.form-field {
  padding: 10px 0;
}

.form-content {
  padding: 0 10px;
}

.form-field-label {
  display: block;
  color: $color-primary-black;
  margin-bottom: 10px;

  .description {
    font-size: 13px;
  }
}

.theme-vip-member .form-field-label {
  &:before {
    content: "";
    display: inline-block;
    width: 9px;
    height: 9px;
    background: url("/static/images/ic-vip-dot.png");
    background-size: 9px 9px;
    margin-right: 12px;
  }
}

.selector {
  margin-bottom: 20px;

  &:last-child {
    margin-bottom: 10px;
  }
}

.description {
  color: $color-primary-grey;
  font-size: 12px;
}

.field-display {
  display: flex;
  flex-flow: row wrap;
  padding: 12px 20px;
  background-color: $color-genesis-white;
  line-height: 2.5em;
  box-sizing: border-box;
}

.theme-vip-member .field-display {
  border: 2px $color-skm-gold solid;
  background-color: transparent;
}

.field-display-label {
  flex: 1 1 40%;
}

.field-display-value {
  flex: 1 1 60%;
  text-align: right;
  font-weight: bold;
}

.edit-button {
  display: block;
  width: 100%;
  border: none;
  background: transparent;
  padding: 0;
  color: $color-skm-red;
  text-align: right;
  line-height: 3em;
  cursor: pointer;

  &:before {
    content: "";
    display: inline-block;
    width: 14px;
    height: 14px;
    background-image: url("/static/images/ic-form-edit.svg");
    margin-right: 0.3em;
  }
}

.note-editor {
  height: 109px;
}

.requirement-list .picker-control {
  display: inline-block;
  width: 42px;
  margin: 0 0.3em;
}

.requirement-item {
  margin-bottom: 10px;

  &:last-child {
    margin-bottom: 0;
  }
}

.buttons {
  padding: 30px 0 0;
}

.button {
  cursor: pointer;
  display: block;
  padding: 0;
  width: 225px;
  line-height: 48px;
  color: $color-white;
  text-align: center;
  margin: 0 auto 10px;
  border: none;
  background: $color-skm-red;
  border-radius: 2px;

  &:disabled {
    opacity: 0.3;
  }

  &.disabled {
    background: $color-pigeon-grey;
  }

  @include media-breakpoint-up(md) {
    width: 315px;
  }
}

.name-input-wrapper {
  display: inline-block;
  position: relative;
  width: 100%;

  @include media-breakpoint-up(md) {
    width: 380px;
  }
}

.gender-selector {
  position: absolute;
  right: 0;
  top: 0;
  width: auto;
  color: $color-skm-red;
  text-align: right;

  select {
    border: none;
    background: transparent;
    color: $color-skm-red;
    width: auto;
    padding-right: 34px;
  }
}

.success-message {
  text-align: center;
  margin-bottom: 10px;

  .message-1 {
    display: block;
    color: $color-skm-red;
    font-size: 30px;
    margin-bottom: 10px;
  }

  .message-2 {
    display: block;
    color: $color-secondary-black;
  }
}

.error-message {
  background: #ffe6e6;
  border: 1px $color-skm-red solid;
  color: $color-skm-red;
  padding: 20px;
  margin-top: 20px;
}

.message-vip {
  /deep/.count {
    color: $color-skm-gold;
  }

  display: block;
  margin-bottom: 12px;
  color: $color-primary-black;
}

.account-info-container.succeeded {
  text-align: center;
}

.account-info-container {
  margin-bottom: 10px;

  @include media-breakpoint-up(md) {
    margin-left: -20px;
  }
}
</style>
